// Copyright © 2012 Cloudera, Inc. All rights reserved.

define(["cloudera/cmf/include/ServiceStatusHealthTablePopup","knockout","underscore"],function(e,t,n){describe("ServiceStatusHealthTablePopup tests",function(){var r={tableId:"serviceStatusHealthTablePopupTable",roles:[{host:{hostName:"host1"}},{host:{hostName:"host2"}}],healthTestSummary:{}},i,s,o={fnSort:jasmine.createSpy(),fnSettings:jasmine.createSpy(),redrawTable:jasmine.createSpy()},u=e.HealthCheck,a=e.HealthCheckResult,f=e.filterHealthSummary,l=function(e){return{id:e,name:e}},c=function(e,t){return{text:e,tag:t}},h=function(e,t){var n=[],r;for(r=0;r<t;r++)n.push({name:"Host "+r});return{health:c(e,e),roles:n}},p=function(e){return{shortDisplayName:e,longDisplayName:e+" "+e,summary:[h("health1",1),h("health2",2)]}};beforeEach(function(){spyOn($.fn,"dataTable").andReturn(o),i=new e(r),s=$('<div id="serviceStatusHealthTablePopup"></div>').appendTo("body")}),afterEach(function(){s.remove()}),it("instantiates a RoleInstancesTable",function(){expect(i.roleInstancesTable).toBeTruthy()}),it("sorts by name as well as status",function(){expect($.fn.dataTable).wasCalled();var e=$.fn.dataTable.mostRecentCall.args[0];expect(e).toBeDefined(),expect(n.isArray(e.aaSorting)).toBeTruthy(),expect(e.aaSorting.length).toEqual(2);var t=e.aaSorting[0],r=e.aaSorting[1];expect(t.length).toEqual(2),expect(r.length).toEqual(2),expect(t[0]).toEqual(8),expect(t[1]).toEqual("asc"),expect(r[0]).toEqual(4),expect(r[1]).toEqual("asc")}),it("is not filtering by default",function(){expect(i.currentHealthCheckFilter()).toBeFalsy()}),it("applies the Knockout bindings during instantiation",function(){spyOn(t,"applyBindings"),i=new e(r),expect(t.applyBindings).wasCalledWith(i,s[0])}),it("does not show stats for empty summaries",function(){var e=new u({summary:{}});expect(e.stats).toEqual([])}),it("ignores stats for HISTORY_NOT_AVAIL",function(){var e=new u({summary:{HISTORY_NOT_AVAIL:h("unknown",0)}});expect(e.stats).toEqual([])}),it("sorts severities RED > YELLOW > NOT_AVAIL > GREEN",function(){var e=new u({summary:{GREEN:h("green",1),NOT_AVAIL:h("notAvail",2),YELLOW:h("yellow",3),RED:h("red",4)}});expect(e.stats).toBeDefined(),expect(e.stats.length).toEqual(4),expect(e.stats[0].html).toEqual('<span class="redHealth">4 red</span>'),expect(e.stats[1].html).toEqual('<span class="yellowHealth">3 yellow</span>'),expect(e.stats[2].html).toEqual('<span class="notAvailHealth">2 notAvail</span>'),expect(e.stats[3].html).toEqual('<span class="greenHealth">1 green</span>')}),it("returns summaries of the health checks",function(){i.healthSummary={SOME_CHECK1:p("Some Check1"),SOME_CHECK2:p("Some Check2")};var e=i.getSummary();expect(e.length).toEqual(2),expect(e[0].displayName).toEqual("Some Check1"),expect(e[1].displayName).toEqual("Some Check2")}),it("filters by health check roles when asked",function(){var e=jasmine.createSpy().andReturn("Host 3");i.roleInstancesTable={setFilterFunc:jasmine.createSpy(),redrawTable:jasmine.createSpy(),getHostName:e};var t=new a(h("green",7));i.filterByHealthCheckRoles(t),expect(i.roleInstancesTable.setFilterFunc).wasCalled(),expect(i.roleInstancesTable.redrawTable).wasCalled(),expect(i.roleInstancesTable.setFilterFunc.mostRecentCall.args.length).toEqual(1);var n=i.roleInstancesTable.setFilterFunc.mostRecentCall.args[0];expect(n(null)).toBeTruthy(),expect(n([])).toBeTruthy(),e.andReturn("Host 2");var r=["0","1","2","Host 2"];expect(n(r)).toBeTruthy(),e.andReturn("Host 37"),r=["0","1","2","Host 37"],expect(n(r)).toBeFalsy()}),it("correctly removes the filter once added",function(){i.roleInstancesTable={clearFilterFunc:jasmine.createSpy(),redrawTable:jasmine.createSpy()},spyOn(i,"currentHealthCheckFilter"),i.removeFilter(),expect(i.roleInstancesTable.clearFilterFunc).wasCalled(),expect(i.roleInstancesTable.redrawTable).wasCalled(),expect(i.currentHealthCheckFilter).wasCalledWith(null)}),it("summarizes a health check correctly",function(){var e=new a(h("green",5));expect(e.html).toEqual('<span class="greenHealth">5 green</span>'),expect(e.hostNames).toBeDefined(),expect(e.hostNames.length).toEqual(5)}),it("has a function called filterHealthSummary",function(){expect(f).toBeDefined()}),it("filters health checks we do not care about",function(){var e={HEALTH_CHECK_1:{summary:{GREEN:{roles:[l("h1")]}}},HEALTH_CHECK_2:{summary:{GREEN:{roles:[l("h2")]}}}},t={h2:!0},n=f(e,t);expect(n.HEALTH_CHECK_1).toBeUndefined(),expect(n.HEALTH_CHECK_2).toBeDefined()}),it("filters health check summaries we do not care about",function(){var e={HEALTH_CHECK_1:{summary:{GREEN:{roles:[l("h1")]},YELLOW:{roles:[l("h2")]}}}},t={h2:!0},n=f(e,t);expect(n.HEALTH_CHECK_1).toBeDefined(),expect(n.HEALTH_CHECK_1.summary.GREEN).toBeUndefined(),expect(n.HEALTH_CHECK_1.summary.YELLOW).toBeDefined()}),it("filters roles we do not care about",function(){var e={HEALTH_CHECK_1:{summary:{GREEN:{roles:[l("h1"),l("h2"),l("h3")]},YELLOW:{roles:[l("h2"),l("h3"),l("h4")]}}},HEALTH_CHECK_2:{summary:{GREEN:{roles:[l("h1"),l("h2"),l("h3")]},YELLOW:{roles:[l("h2"),l("h3"),l("h4")]}}}},t={h2:!0,h3:!0},n=f(e,t),r=n.HEALTH_CHECK_1.summary.GREEN.roles,i=n.HEALTH_CHECK_1.summary.YELLOW.roles,s=n.HEALTH_CHECK_2.summary.GREEN.roles,o=n.HEALTH_CHECK_2.summary.YELLOW.roles,u=function(e){expect(e[0].name).toEqual("h2"),expect(e[1].name).toEqual("h3")};expect(r.length).toEqual(2),u(r),expect(i.length).toEqual(2),u(i),expect(s.length).toEqual(2),u(s),expect(o.length).toEqual(2),u(o)})})})